Graphics3D 800,600,32,2
SetBuffer BackBuffer()

pxCreateWorld(1,"")

cam = CreateCamera()
PositionEntity cam,0,10,-20

plane = CreatePlane()
EntityColor plane,64,128,128

light = CreateLight()



Repeat

If KeyHit(57) Then CreatepxBody(0,10,0)

pxRenderPhysic(60,0)
UpdatepxBodies()

RenderWorld()
Flip

Until KeyHit(1)
End

Type pxBody
	Field mesh
	Field body
End Type

Function UpdatepxBodies()
	For pxB.pxBody = Each pxBody
		pxBodySetEntity pxB\mesh, pxB\body
	Next
End Function

Function CreatepxBody(x#,y#,z#)	
	pxB.pxBody = New pxBody
	fig = Rand(1,4)
	Select fig
		Case 1 ; 
			pxB\mesh = CreateCube()
			pxB\body = pxBodyCreateCube(1,1,1,1)
		Case 2 ; 
			pxB\mesh = CreateCylinder(8)
			ScaleEntity pxb\mesh,1,3,1
			pxB\body = pxBodyCreateCylinder(1, 3, 8, 1)
		Case 3 ; 
			pxB\mesh = CreateSphere(8)
			pxB\body = pxBodyCreateSphere(1,1)
		Case 4 ; 
			pxB\mesh = CreateCapsule(3,1)
			pxB\body = pxBodyCreateCapsule(3,1,1)
	End Select
	pxBodySetPosition pxB\body,x,y,z
End Function

Function CreateCapsule(height#,radius# )
	cyl = CreateCylinder()
	ScaleMesh cyl, radius, height-radius*1.5, radius
	
	sph = CreateSphere()
	ScaleEntity sph, radius,radius,radius
	PositionMesh sph, 0,height/2,0
	AddMesh sph, cyl
	
	PositionMesh sph, 0,-height,0
	AddMesh sph, cyl

	FreeEntity sph
	Return cyl
End Function